100 ' Zahnrad-Zeichenprogramm
110 ' 1990 by A. Meile
120 :
130 SCREEN 1:CLS:KEY ON:KEY OFF:COLOR 17,2,2
135 WINDOW (0!,0!)-(245.6,157.7786)
140 X!=28.9:Y!=126.65 ' Mittelpunkt
150 M!=2.5            ' Modul
160 Z%=19             ' Zhnezahl
170 AL!=4!            ' Lagewinkel
180 HFF!=1.25         ' Fusshhenfaktor
190 HAF!=1!           ' Kopfhhenfaktor
200 BET!=20!          ' Eingriffswinkel
210 GEN1%=11          ' Genauigkeit der Zahnflanken
220 GEN2%=3           ' Genauigkeit der Zwischenbogen
230 :
235 C%=3:GOSUB 1000
240 C%=2:NZ%=42:W!=290!
250 GOSUB 2000:GOSUB 1000
260 NZ%=20:W!=65!
270 GOSUB 2000:C%=1:GOSUB 1000
280 NZ%=22:W!=350!:C%=3
290 GOSUB 2000:GOSUB 1000
300 NZ%=35:W!=291!:C%=1
310 GOSUB 2000:GOSUB 1000
320 NZ%=17:W!=60!:C%=2
330 GOSUB 2000:GOSUB 1000
340 :
350 END
1000 ' Unterprogramm ZeichneZahnrad
1010 :
1020 ' Eingangsparameter (Variablen):
1030 ' x!,y!  : Mittelpunkt des Zahnrades auf dem Bildschirm
1040 ' m!     : Modul des Zahnrades (in Bildpunkten!)
1050 ' z%     : Zhnezahl des Zahnrades
1060 ' hff!   : Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
1070 ' haf!   : Kopfhhenfaktor (bei genormten Rder normalerweise 1)
1080 ' Bet!   : Eingriffswinkel in  (bei genormten Rder normalerweise 20)
1090 ' Al!    : Lagewinkel des ersten Zahnes in 
1100 ' Gen1%  : Zeichengenauigkeit der Evolvente (Anzahl Linien)
1110 ' Gen2%  : Zeichengenauigkeit der Kopf- und Fusskreisausschnitte
1115 ' c%     : Zeichenfarbe des Rades
1120 :
1130 IF HFF!>CSNG(Z%)/2! THEN HFF!=CSNG(Z%)/2!
1140 D!=M!*CSNG(Z%)
1150 PI!=4!*ATN(1!)
1160 DF!=D!-2!*M!*HFF!
1170 DA!=D!+2!*M!*HAF!
1180 ALR!=AL!/180!*PI!
1190 BETR!=BET!/180!*PI!
1200 DG!=D!*COS(BETR!)
1210 IF DF!<DG! THEN E%=-1:SWFR!=0!:ELSE E%=0:SWFR!=SQR(DF!*DF!-DG!*DG!)/DG!
1220 SWAR!=SQR(DA!*DA!-DG!*DG!)/DG!
1230 TEILW!=2!*PI!/CSNG(Z%)
1240 DELR!=TAN(BETR!)
1250 WW!=TEILW!/4!-BETR!+DELR!
1260 WFR!=WW!-SWFR!+ATN(SWFR!)
1270 WAR!=WW!-SWAR!+ATN(SWAR!)
1280 F%=WFR!<TEILW!/2!
1290 A%=WAR!>0!
1300 IF A% THEN 1350
1310 SWAR!=1024!:H!=512!
1320 FOR I%=0 TO 80
1330 IF SWAR!-WW!>ATN(SWAR!) THEN SWAR!=SWAR!-H!:ELSE SWAR!=SWAR!+H!
1335 H!=H!/2!
1340 NEXT I%
1350 IF F% THEN 1400
1360 SWFR!=1024!:H!=512!
1370 FOR I%=0 TO 80
1380 IF SWFR!-WW!+TEILW!/2!>ATN(SWFR!) THEN SWFR!=SWFR!-H!:ELSE SWFR!=SWFR!+H!
1390 H!=H!/2!
1395 NEXT I%
1400 R!=DG!/2!
1410 SW!=(SWAR!-SWFR!)/CSNG(GEN1%)
1420 S!=ALR!+WAR!
1430 W!=ALR!+WW!:A!=W!-SWAR!:B!=-SWAR!*R!
1435 PSET (X!+R!*COS(A!)+B!*SIN(A!),Y!+R!*SIN(A!)-B!*COS(A!)),C%
1440 FOR ZAHN%=0 TO Z%-1
1450 LWR!=ALR!+TEILW!*CSNG(ZAHN%)
1460 SWR!=-SWAR!
1470 W!=LWR!+WW!
1480 GOSUB 1600
1485 IF NOT F% THEN 1530
1490 S1!=LWR!+WFR!:E1!=LWR!+TEILW!-WFR!
1500 IF E% THEN LINE -(X!+DF!/2!*COS(S1!),Y!+DF!/2!*SIN(S1!)),C%
1510 R1!=DF!/2!:GOSUB 1660
1520 IF E% THEN LINE -(X!+R!*COS(E1!),Y!+R!*SIN(E1!)),C%
1530 SWR!=SWFR!
1535 W!=LWR!-WW!+TEILW!
1540 GOSUB 1600
1550 S1!=LWR!-WAR!+TEILW!:E1!=LWR!+TEILW!+WAR!
1560 R1!=DA!/2!:IF A% THEN GOSUB 1660
1570 NEXT ZAHN%
1575 PAINT (X!,Y!),C%
1580 RETURN
1590 :
1600 FOR I%=1 TO GEN1%
1610 A!=W!+SWR!+CSNG(I%)*SW!:B!=(A!-W!)*R!
1620 LINE -(X!+R!*COS(A!)+B!*SIN(A!),Y!+R!*SIN(A!)-B!*COS(A!)),C%
1630 NEXT I%
1640 RETURN
1650 :
1660 S!=(E1!-S1!)/CSNG(GEN2%)
1670 FOR I%=1 TO GEN2%
1680 S2!=S1!+CSNG(I%)*S!
1690 LINE -(X!+R1!*COS(S2!),Y!+R1!*SIN(S2!)),C%
1700 NEXT I%
1710 RETURN
1720 :
2000 ' Unterprogramm BerechneNeulage
2010 :
2020 ' Eingangsparameter (Variablen):
2030 ' x!,y!,m!,z%,Al! : Alte Werte; diese werden entsprechend verndert
2040 ' nz%             : Neue Zhnezahl
2050 ' w!              : Lgewinkel des eingreifenden Rades relativ zum alten
2060 '                   Rades
2070 :
2080 A!=CSNG(Z%+NZ%)*M!/2!
2090 UM!=ATN(1!)/45!
2100 X!=X!+A!*COS(W!*UM!)
2110 Y!=Y!+A!*SIN(W!*UM!)
2120 AL!=W!-180!+180!/CSNG(NZ%)+(W!-AL!)*CSNG(Z%)/CSNG(NZ%)
2125 Z%=NZ%
2130 RETURN
