100 ' *** Zahnrad-Zeichenprogramm ***
110 ' Version berarbeitet; es wurde erneuert:
120 '           - Anpassung an die Normung
130 '           - Neu lassen sich auch V-Verzahnungen erzeugen
140 :
150 SCREEN 9:KEY OFF:CLS:WINDOW (0!,0!)-(337!,252!):PI!=4!*ATN(1!)
160 FA%=12
170 LX!=126!:LY!=126!
180 LAL!=90!/23!
190 Z%=30:M!=8!:X!=-.3
200 AL!=20!:HFF!=1.25:HAF!=1!
210 GEN%=5
220 GOSUB 1000
230 NZ%=11:A!=165!:FA%=14:W!=24!
240 GOSUB 2000:GOSUB 1000
250 END
260 :
1000 ' Unterprogramm ZeichneZahnrad
1010 :
1020 ' Eingangsparameter (Variablen):
1030 ' LX!, LY! : Mittelpunkt des Zahnrades (bildschirmbezogen)
1040 ' LAL!     : Zahnstellung des ersten Zahnes in 
1050 ' M!       : Modul (Bildpunkte)
1060 ' Z%       : Zhnezahl
1070 ' X!       : Profilverschiebungsfaktor gemss Norm (0=unkorrigiert)
1080 ' HFF!     : Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
1090 ' HAF!     : Kopfhhenfaktor (bei genormten Rder normalerweise 1)
1100 ' AL!      : Eingriffswinkel in  (bei genormten Rder normalerweise 20)
1110 ' Gen%     : Zeichengenauigkeit der Evolvente (Anzahl Linien)
1120 :
1130 IF HFF!>CSNG(Z%)/2!+X! THEN HFF!=CSNG(Z%)/2!+X!
1140 D!=M!*CSNG(Z%)
1150 DF!=D!-2!*M!*(HFF!-X!)
1160 DA!=D!+2!*M!*(HAF!+X!)
1170 LALR!=LAL!/180!*PI!
1180 ALR!=AL!/180!*PI!
1190 DG!=D!*COS(ALR!)
1200 E%=DF!<DG!
1210 IF E% THEN SWFR!=0! ELSE SWFR!=SQR(DF!*DF!-DG!*DG!)/DG!
1220 SWAR!=SQR(DA!*DA!-DG!*DG!)/DG!
1230 TEILW!=2!*PI!/CSNG(Z%)
1240 DELR!=TAN(ALR!)
1250 WW!=TEILW!/4!-ALR!+DELR!*(1!+X!*2!/CSNG(Z%))
1260 WFR!=WW!-SWFR!+ATN(SWFR!)
1270 WAR!=WW!-SWAR!+ATN(SWAR!)
1280 F%=WFR!<TEILW!/2!
1290 A%=WAR!>0!
1300 IF A% THEN 1360
1310 SWAR!=1024!:H!=512!
1320 FOR I%=0 TO 80
1330 IF SWAR!-WW!>ATN(SWAR!) THEN SWAR!=SWAR!-H! ELSE SWAR!=SWAR!+H!
1340 H!=H!/2!
1350 NEXT I%
1360 IF F% THEN 1420
1370 SWFR!=1024!:H!=512!
1380 FOR I%=1 TO 80
1390 IF SWFR!-WW!+TEILW!/2!>ATN(SWFR!) THEN SWFR!=SWFR!-H! ELSE SWFR!=SWFR!+H!
1400 H!=H!/2!
1410 NEXT I%
1420 R!=DG!/2!
1430 SW1!=(SWAR!-SWFR!)/CSNG(GEN%)
1440 FOR ZAHN%=0 TO Z%-1
1450 LWR!=LALR!+CSNG(ZAHN%)*TEILW!
1460 SWR!=SWFR!
1470 W!=LWR!-WW!
1480 GOSUB 1650
1490 IF NOT A% THEN 1530
1500 SW!=LWR!-WAR!:EW!=LWR!+WAR!
1510 RX!=DA!/2!:RY!=RX!
1520 CIRCLE (LX!,LY!),RX!,FA%,SW!-2!*PI!*INT(SW!/2!/PI!),EW!-2!*PI!*INT(EW!/2!/PI!)
1530 SWR!=-SWAR!
1540 W!=LWR!+WW!
1550 GOSUB 1650
1560 IF NOT F% THEN 1620
1570 SW!=LWR!+WFR!:EW!=LWR!-WFR!+TEILW!
1580 IF E% THEN X1!=LX!+DF!/2!*COS(SW!):Y1!=LY!+DF!/2!*SIN(SW!):X2!=LX!+R!*COS(SW!):Y2!=LY!+R!*SIN(SW!):LINE (X1!,Y1!)-(X2!,Y2!),FA%
1590 RX!=DF!/2!:RY!=RX!
1600 CIRCLE (LX!,LY!),RX!,FA%,SW!-2!*PI!*INT(SW!/2!/PI!),EW!-2!*PI!*INT(EW!/2!/PI!)
1610 IF E% THEN X1!=LX!+R!*COS(EW!):Y1!=LY!+R!*SIN(EW!):X2!=LX!+DF!/2!*COS(EW!):Y2!=LY!+DF!/2!*SIN(EW!):LINE (X1!,Y1!)-(X2!,Y2!),FA%
1620 NEXT ZAHN%
1630 RETURN
1640 :
1650 A!=W!+SWR!:B!=SWR!*R!:X2!=LX!+R!*COS(A!)+B!*SIN(A!):Y2!=LY!+R!*SIN(A!)-B!*COS(A!)
1660 FOR I%=1 TO GEN%
1670 X1!=X2!:Y1!=Y2!
1680 A!=W!+SWR!+CSNG(I%)*SW1!:B!=(A!-W!)*R!:X2!=LX!+R!*COS(A!)+B!*SIN(A!):Y2!=LY!+R!*SIN(A!)-B!*COS(A!)
1690 LINE (X1!,Y1!)-(X2!,Y2!),FA%
1700 NEXT I%
1710 RETURN
1720 :
2000 ' Unterprogramm BerechneNeulage
2010 :
2020 ' Eingangsparameter (Variablen):
2030 ' LX!, LY!, M!, Z%, LAL! : Alte Werte; diese werden entsprechend verndert
2040 ' A!                     : Achsabstand; betrgt er 0, dann wird eine
2050 '                        : V-Null-Verzahnung berechnet
2060 ' NZ%                    : Neue Zhnezahl; beim Wert 0 berechnet das Pro-
2070 '                        : gramm eine Zhnezahl, die mglichst nahe an
2080 '                        : die V-Null-Verzahnung herankommt; der Korrek-
2090 '                        : turfaktor wird dabei automatisch angepasst
2100 ' W!                     : Lagewinkel, vom letzten Rad aus gesehen
2110 :
2120 IF A!=0! THEN 2170
2130 IF NZ%=0 THEN NZ%=CINT(2!*A!/M!)-Z%
2140 H3!=AL!/180!*PI!:H1!=M!*CSNG(Z%+NZ%)*COS(H3!)/2!/A!:H2!=SQR(1!-H1!*H1!)/H1!
2150 X!=CSNG(Z%+NZ%)*((H2!-ATN(H2!)+H3!)/TAN(H3!)-1!)/2!-X!
2160 GOTO 2180
2170 A!=CSNG(Z%+NZ%)*M!/2!:X!=-X!
2180 LX!=LX!+A!*COS(W!/180!*PI!):LY!=LY!+A!*SIN(W!/180!*PI!)
2190 LAL!=W!-180!+180!/CSNG(NZ%)+(W!-LAL!)*CSNG(Z%)/CSNG(NZ%)
2200 Z%=NZ%
2210 RETURN
2220 :
