100 ' *** Zahnrad-Zeichenprogramm ***
105 ' Version berarbeitet; es wurde erneuert:
110 '           - Anpassung an die Normung
115 '           - Neu lassen sich auch V-Verzahnungen erzeugen
120 ' Grafikplotter auf einem normalen 9-Nadel-Matrixdrucker
130 ' Druckt Grafik mit einer Auflsung von 240x216 dpi
140 :
150 SCREEN 9:KEY OFF:CLS:WINDOW (0!,0!)-(337!,252!):PI!=4!*ATN(1!)
160 DEFSTR A-Z:FA%=10
170 M!=40!:LX!=168.5-7.071068*M!:LY!=126!-7.071068*M!
180 LAL!=90!/23!
190 Z%=20:X!=0!
200 AL!=20!:HFF!=1.25:HAF!=1!
210 GEN%=31
220 TT1%=1:TT2%=4:GOSUB 1000:PAINT (10!,10!),2,10
230 NZ%=100:A!=2400!:FA%=13:W!=45!
240 GOSUB 2000:TT1%=-5:TT2%=-1:HAF!=1!-CSNG(Z%-100)/2!-X!:HFF!=1.25+CSNG(Z%-100)/2!+X!:GOSUB 1000:PAINT (327!,242!),5,13
250 END
260 :
1000 ' Unterprogramm ZeichneZahnrad
1010 :
1020 ' Eingangsparameter (Variablen):
1030 ' LX!, LY! : Mittelpunkt des Zahnrades (bildschirmbezogen)
1040 ' LAL!     : Zahnstellung des ersten Zahnes in 
1050 ' M!       : Modul (Bildpunkte)
1060 ' Z%       : Zhnezahl
1070 ' X!       : Profilverschiebungsfaktor gemss Norm (0=unkorrigiert)
1080 ' HFF!     : Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
1090 ' HAF!     : Kopfhhenfaktor (bei genormten Rder normalerweise 1)
1100 ' AL!      : Eingriffswinkel in  (bei genormten Rder normalerweise 20)
1110 ' Gen%     : Zeichengenauigkeit der Evolvente (Anzahl Linien)
1120 :
1130 IF HFF!>CSNG(Z%)/2!+X! THEN HFF!=CSNG(Z%)/2!+X!
1140 D!=M!*CSNG(Z%)
1150 DF!=D!-2!*M!*(HFF!-X!)
1160 DA!=D!+2!*M!*(HAF!+X!)
1170 LALR!=LAL!/180!*PI!
1180 ALR!=AL!/180!*PI!
1190 DG!=D!*COS(ALR!)
1200 E%=DF!<DG!
1210 IF E% THEN SWFR!=0! ELSE SWFR!=SQR(DF!*DF!-DG!*DG!)/DG!
1220 SWAR!=SQR(DA!*DA!-DG!*DG!)/DG!
1230 TEILW!=2!*PI!/CSNG(Z%)
1240 DELR!=TAN(ALR!)
1250 WW!=TEILW!/4!-ALR!+DELR!*(1!+X!*2!/CSNG(Z%))
1260 WFR!=WW!-SWFR!+ATN(SWFR!)
1270 WAR!=WW!-SWAR!+ATN(SWAR!)
1280 F%=WFR!<TEILW!/2!
1290 A%=WAR!>0!
1300 IF A% THEN 1360
1310 SWAR!=1024!:H!=512!
1320 FOR I%=0 TO 80
1330 IF SWAR!-WW!>ATN(SWAR!) THEN SWAR!=SWAR!-H! ELSE SWAR!=SWAR!+H!
1340 H!=H!/2!
1350 NEXT I%
1360 IF F% THEN 1420
1370 SWFR!=1024!:H!=512!
1380 FOR I%=1 TO 80
1390 IF SWFR!-WW!+TEILW!/2!>ATN(SWFR!) THEN SWFR!=SWFR!-H! ELSE SWFR!=SWFR!+H!
1400 H!=H!/2!
1410 NEXT I%
1420 R!=DG!/2!
1430 SW1!=(SWAR!-SWFR!)/CSNG(GEN%)
1440 FOR ZAHN%=TT1% TO TT2%
1450 LWR!=LALR!+CSNG(ZAHN%)*TEILW!
1460 SWR!=SWFR!
1470 W!=LWR!-WW!
1480 GOSUB 1650
1490 IF NOT A% THEN 1530
1500 SW!=LWR!-WAR!:EW!=LWR!+WAR!
1510 RX!=DA!/2!:RY!=RX!
1520 CIRCLE (LX!,LY!),RX!,FA%,SW!-2!*PI!*INT(SW!/2!/PI!),EW!-2!*PI!*INT(EW!/2!/PI!)
1530 SWR!=-SWAR!
1540 W!=LWR!+WW!
1550 GOSUB 1650
1560 IF NOT F% THEN 1620
1570 SW!=LWR!+WFR!:EW!=LWR!-WFR!+TEILW!
1580 IF E% THEN X1!=LX!+DF!/2!*COS(SW!):Y1!=LY!+DF!/2!*SIN(SW!):X2!=LX!+R!*COS(SW!):Y2!=LY!+R!*SIN(SW!):LINE (X1!,Y1!)-(X2!,Y2!),FA%
1590 RX!=DF!/2!:RY!=RX!
1600 CIRCLE (LX!,LY!),RX!,FA%,SW!-2!*PI!*INT(SW!/2!/PI!),EW!-2!*PI!*INT(EW!/2!/PI!)
1610 IF E% THEN X1!=LX!+R!*COS(EW!):Y1!=LY!+R!*SIN(EW!):X2!=LX!+DF!/2!*COS(EW!):Y2!=LY!+DF!/2!*SIN(EW!):LINE (X1!,Y1!)-(X2!,Y2!),FA%
1620 NEXT ZAHN%
1630 RETURN
1640 :
1650 A!=W!+SWR!:B!=SWR!*R!:X2!=LX!+R!*COS(A!)+B!*SIN(A!):Y2!=LY!+R!*SIN(A!)-B!*COS(A!)
1660 FOR I%=1 TO GEN%
1670 X1!=X2!:Y1!=Y2!
1680 A!=W!+SWR!+CSNG(I%)*SW1!:B!=(A!-W!)*R!:X2!=LX!+R!*COS(A!)+B!*SIN(A!):Y2!=LY!+R!*SIN(A!)-B!*COS(A!)
1690 LINE (X1!,Y1!)-(X2!,Y2!),FA%
1700 NEXT I%
1710 RETURN
1720 :
2000 ' Unterprogramm BerechneNeulage
2010 :
2020 ' Eingangsparameter (Variablen):
2030 ' LX!, LY!, M!, Z%, LAL! : Alte Werte; diese werden entsprechend verndert
2040 ' A!                     : Achsabstand; betrgt er 0, dann wird eine
2050 '                        : V-Null-Verzahnung berechnet
2060 ' NZ%                    : Neue Zhnezahl; beim Wert 0 berechnet das Pro-
2070 '                        : gramm eine Zhnezahl, die mglichst nahe an
2080 '                        : die V-Null-Verzahnung herankommt; der Korrek-
2090 '                        : turfaktor wird dabei automatisch angepasst
2100 ' W!                     : Lagewinkel, vom letzten Rad aus gesehen
2110 :
2120 IF A!=0! THEN 2170
2130 IF NZ%=0 THEN NZ%=CINT(2!*A!/M!)-Z%
2140 H3!=AL!/180!*PI!:H1!=M!*CSNG(Z%+NZ%)*COS(H3!)/2!/A!:H2!=SQR(1!-H1!*H1!)/H1!
2150 X!=CSNG(Z%+NZ%)*((H2!-ATN(H2!)+H3!)/TAN(H3!)-1!)/2!-X!
2160 GOTO 2180
2170 A!=CSNG(Z%+NZ%)*M!/2!:X!=-X!
2180 LX!=LX!+A!*COS(W!/180!*PI!):LY!=LY!+A!*SIN(W!/180!*PI!)
2190 LAL!=W!-180!+180!/CSNG(NZ%)+(W!-LAL!)*CSNG(Z%)/CSNG(NZ%)
2200 Z%=NZ%
2210 RETURN
2220 :
9000 ' Modulsammlung fr den Grafikdruck
9010 ' Zeile 10000 : Zeichnet Punkt in Integerkoordinaten (x%,y%)
9020 ' Zeile 11000 : Zeichnet Linie in mm-Realkoordinaten (x1!,y1!,x2!,y2!)
9030 ' Zeile 12000 : Zeichnet Kreisbogen (oder Kreis oder Orthogonalellipse)
9040 '             : in mm-Realkoordinaten (x!,y!,rx!,ry!,sw!,ew! [rad])
9045 ' Zeile 13000 : Zeichnet Punkt in mm-Realkoordinaten (x!,y!)
9050 ' Zeile 14000 : ffnet Temporrdatei und richtet alle ntigen Variablen
9060 '               ein
9070 ' Zeile 15000 : Druckt Grafik aus
9080 ' Zeile 16000 : Schliesst und lscht Temporrdatei
9090 :
10000 IF X%<0 OR X%>XB% OR Y%<0 OR Y%>YB% THEN RETURN
10010 DS%=((Y%\24)*3+Y% MOD 3)*XS%+X%\128+1:GET 1,DS%
10020 XH%=(X% AND 127)+1:MID$(D$,XH%)=CHR$(ASC(MID$(D$,XH%,1))OR HF%(Y%\3 AND 7)):PUT 1,DS%
10030 RETURN
11000 XA!=X1!*1200!/127!:YA!=Y1!*1080!/127!
11010 XB!=X2!*1200!/127!:YB!=Y2!*1080!/127!
11020 X1%=CINT(XA!):Y1%=CINT(YA!):X2%=CINT(XB!):Y2%=CINT(YB!)
11030 SX%=SGN(X2%-X1%):SY%=SGN(Y2%-Y1%)
11040 IF SX%=0 THEN X%=X1%:FOR Y%=Y1% TO Y2% STEP SY%:GOSUB 10000:NEXT Y%:RETURN
11050 IF SY%=0 THEN Y%=Y1%:FOR X%=X1% TO X2% STEP SX%:GOSUB 10000:NEXT X%:RETURN
11060 S!=(YB!-YA!)/(XB!-XA!):T!=YA!-XA!*S!:X%=X1%:Y%=Y1%:GOSUB 10000
11070 WHILE X%<>X2% OR Y%<>Y2%:Z1!=ABS(T!+S!*CSNG(X%+SX%)-CSNG(Y%))
11080 Z2!=ABS(T!+S!*CSNG(X%)-CSNG(Y%+SY%))
11090 IF Z1!<Z2! THEN X%=X%+SX% ELSE Y%=Y%+SY%
11100 GOSUB 10000:WEND
11110 RETURN
12000 X1!=X!*1200!/127!:Y1!=Y!*1080!/127!
12010 RX1!=RX!*1200!/127!:RY1!=RY!*1080!/127!
12020 X%=CINT(X1!+RX1!*COS(SW!)):Y%=CINT(Y1!+RY1!*SIN(SW!))
12030 X2%=CINT(X1!+RX1!*COS(EW!)):Y2%=CINT(Y1!+RY1!*SIN(EW!))
12040 GOSUB 10000:SX%=SGN(Y1!-CSNG(Y%)):SY%=SGN(CSNG(X%)-X1!):A!=RX1!/RY1!:T%=-1
12050 WHILE X%<>X2% OR Y%<>Y2% OR T%:XA!=CSNG(X%+SX%)-X1!:YA!=(Y1!-CSNG(Y%))*A!
12060 XB!=CSNG(X%)-X1!:YB!=(Y1!-CSNG(Y%+SY%))*A!
12070 IF SX% THEN Z1!=ABS(SQR(XA!*XA!+YA!*YA!)-RX1!) ELSE Z1!=2!
12080 IF SY% THEN Z2!=ABS(SQR(XB!*XB!+YB!*YB!)-RX1!) ELSE Z2!=2!
12090 IF Z1!<Z2! THEN X%=X%+SX%:SY%=SGN(XA!) ELSE Y%=Y%+SY%:SX%=SGN(YB!)
12100 GOSUB 10000:T%=0:WEND
12110 RETURN
13000 X%=CINT(X!*1200!/127!):Y%=CINT(Y!*1080!/127!)
13010 GOSUB 10000:RETURN
14000 PI!=4!*ATN(1!)
14010 XS%=CINT(X!*1200!/127!)\128+1
14020 XB%=XS%*128-1
14030 YS%=CINT(Y!*1080!/127!)\24+1
14040 YB%=YS%*24-1
14050 OPEN "GrafDat.$$$" AS 1 LEN=128
14060 FIELD 1,128 AS D$
14070 LSET D$=STRING$(128,0)
14080 FOR I%=1 TO XS%*YS%*3:PUT 1,I%:NEXT I%
14090 FOR I%=0 TO 7:HF%(I%)=CINT(2!^CSNG(I%)):NEXT I%
14100 RETURN
15000 OPEN "Prn" FOR OUTPUT AS 2
15010 PRINT#2,CHR$(27);"@"
15020 FOR Y%=3*(YS%-1)*XS% TO 0 STEP -XS%*3
15030 PRINT#2,CHR$(27);"3";CHR$(1);
15040 FOR Y1%=Y%+2*XS% TO Y% STEP -XS%:PRINT#2,""
15050 PRINT#2,CHR$(27);"Z";MKI$(XB%+1);
15060 FOR X%=Y1%+1 TO Y1%+XS%
15070 GET 1,X%:PRINT#2,D$;:NEXT X%
15080 NEXT Y1%
15090 PRINT#2,CHR$(27);"3";CHR$(21)
15100 NEXT Y%
15110 PRINT#2,CHR$(27);"2"
15120 CLOSE 2
15130 RETURN
16000 CLOSE 1
16010 KILL "GrafDat.$$$"
16020 RETURN
